| Demo HCI Implementation for WiMOD-LR Devices V1.3.1

- Main Page
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
WiMOD_SAP_RadioLink Class Reference

Implementation for the ServiceAccessPoint RadioLink (LR-Base firmware only) More...

`#include <SAP/WiMOD_SAP_RadioLink.h>`

## Public Member Functions
| WiMOD_SAP_RadioLink (TWiMODLRHCI *hci, UINT8 *buffer, UINT16 bufferSize)
| Constructor. More...
| ~WiMOD_SAP_RadioLink (void)
| Destructor.
TWiMDLRResultCodes | SendUData (const TWiMODLR_RadioLink_Msg *txMsg, UINT8 *statusRsp)
| Tries to send transmit U-Data to peer module via RF link. More...
bool | convert (TWiMODLR_HCIMessage &RxMsg, TWiMODLR_RadioLink_Msg *radioLinkMsg)
| Convert a received low level HCI-Msg to a high-level RadioLink-Msg. More...
TWiMDLRResultCodes | SendCData (const TWiMODLR_RadioLink_Msg *txMsg, UINT8 *statusRsp)
| Tries to send transmit C-Data to peer module via RF link. More...
bool | convert (TWiMODLR_HCIMessage &RxMsg, TWiMODLR_RadioLink_CdataInd *cDataTxInfo)
| Convert a received low level HCI-Msg to a high-level CDataTx Info. More...
bool | convert (TWiMODLR_HCIMessage &RxMsg, TWiMODLR_AckTxInd_Msg *txAckIndInfo)
| Convert a received low level HCI-Msg to a high-level AckTxInd Info. More...
TWiMDLRResultCodes | SetAckData (const TWiMODLR_RadioLink_Msg *txMsg, UINT8 *statusRsp)
| Sets additional user payload for the next ack frame to send. More...
void | RegisterUDataRxClient (TRadioLinkUDataRxIndicationCallback cb)
| Register a callback function for the RX U-Data Indication - optional -. More...
void | RegisterUDataTxClient (TRadioLinkUDataTxIndicationCallback cb)
| Register a callback function for the TX U-Data Indication - optional -. More...
void | RegisterRawDataRxClient (TRadioLinkRawDataRxIndicationCallback cb)
| Register a callback function for the RX Raw-Data Indication - optional -. More...
void | RegisterCDataRxClient (TRadioLinkCDataRxIndicationCallback cb)
| Register a callback function for the RX C-Data Indication - optional -. More...
void | RegisterCDataTxClient (TRadioLinkCDataTxIndicationCallback cb)
| Register a callback function for the TX C-Data Indication - optional -. More...
void | RegisterAckRxClient (TRadioLinkAckRxIndicationCallback cb)
| Register a callback function for the RX Ack (+data) Indication - optional -. More...
void | RegisterAckRxTimeoutClient (TRadioLinkAckRxTimeoutIndicationCallback cb)
| Register a callback function for the Ack Timeout Indication - optional -. More...
void | RegisterAckTxCallback (TRadioLinkAckTxIndicationCallback cb)
| Register a callback function for the TX Ack Indication - optional -. More...
void | DispatchRadioLinkMessage (TWiMODLR_HCIMessage &rxMsg)

## Detailed Description

Implementation for the ServiceAccessPoint RadioLink (LR-Base firmware only)

## Constructor & Destructor Documentation

WiMOD_SAP_RadioLink::WiMOD_SAP_RadioLink | ( | TWiMODLRHCI * | hci,
|  | UINT8 * | buffer,
|  | UINT16 | bufferSize
| ) |  |

Constructor.

Parameters

  hci | Pointer to HCI processor object
  buffer | pointer to storage area for building tx frames; MUST BE VALID
  bufferSize | size of the buffer

## Member Function Documentation

bool WiMOD_SAP_RadioLink::convert | ( | TWiMODLR_HCIMessage & | RxMsg,
|  | TWiMODLR_RadioLink_Msg * | radioLinkMsg
| ) |  |

Convert a received low level HCI-Msg to a high-level RadioLink-Msg.

This function should be used by the RxUData / RxCData callback functions prior processing the received data message.

Parameters

  RxMsg | Reference to low-level HCI message.

Warning
  DO NOT MANIPULATE THESE VALUES !!!

Parameters

  radioLinkMsg | Pointer to the buffer where to store the received data

Return values

  true | if the conversion was successful

bool WiMOD_SAP_RadioLink::convert | ( | TWiMODLR_HCIMessage & | RxMsg,
|  | TWiMODLR_RadioLink_CdataInd * | cDataTxInfo
| ) |  |

Convert a received low level HCI-Msg to a high-level CDataTx Info.

This function should be used by the Tx-C-Data Indication Callback functions prior processing the received data message.

Parameters

  RxMsg | Reference to low-level HCI message.

Warning
  DO NOT MANIPULATE THESE VALUES !!!

Parameters

  cDataTxInfo | Pointer to the buffer where to store the received data

Return values

  true | if the conversion was successful

bool WiMOD_SAP_RadioLink::convert | ( | TWiMODLR_HCIMessage & | RxMsg,
|  | TWiMODLR_AckTxInd_Msg * | txAckIndInfo
| ) |  |

Convert a received low level HCI-Msg to a high-level AckTxInd Info.

This function should be used by the AckTx Indication Callback functions prior processing the received data message.

Parameters

  RxMsg | Reference to low-level HCI message.

Warning
  DO NOT MANIPULATE THESE VALUES !!!

Parameters

  txAckIndInfo | Pointer to the buffer where to store the received data

Return values

  true | if the conversion was successful

void WiMOD_SAP_RadioLink::RegisterAckRxClient | ( | TRadioLinkAckRxIndicationCallback | cb | ) |

Register a callback function for the RX Ack (+data) Indication - optional -.

See also
  TWiMDLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkAckRxIndicationCallback for details

Note
  : the callback function should call the corresponding convert in order to decode the message properly

void WiMOD_SAP_RadioLink::RegisterAckRxTimeoutClient | ( | TRadioLinkAckRxTimeoutIndicationCallback | cb | ) |

Register a callback function for the Ack Timeout Indication - optional -.

See also
  TWiMDLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkAckRxTimeoutIndicationCallback for details

void WiMOD_SAP_RadioLink::RegisterAckTxCallback | ( | TRadioLinkAckTxIndicationCallback | cb | ) |

Register a callback function for the TX Ack Indication - optional -.

See also
  TWiMDLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkAckTxIndicationCallback for details

void WiMOD_SAP_RadioLink::RegisterCDataRxClient | ( | TRadioLinkCDataRxIndicationCallback | cb | ) |

Register a callback function for the RX C-Data Indication - optional -.

See also
  TWiMDLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkCDataRxIndicationCallback for details

Note
  : the callback function should call the corresponding convert in order to decode the message properly

void WiMOD_SAP_RadioLink::RegisterCDataTxClient | ( | TRadioLinkCDataTxIndicationCallback | cb | ) |

Register a callback function for the TX C-Data Indication - optional -.

See also
  TWiMDLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkCDataTxIndicationCallback for details

Note
  : the callback function should call the corresponding convert in order to decode the message properly

void WiMOD_SAP_RadioLink::RegisterRawDataRxClient | ( | TRadioLinkRawDataRxIndicationCallback | cb | ) |

Register a callback function for the RX Raw-Data Indication - optional -.

See also
  TWiMDLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkRawDataRxIndicationCallback for details

Note
  : the callback function should call the corresponding convert in order to decode the message properly

void WiMOD_SAP_RadioLink::RegisterUDataRxClient | ( | TRadioLinkUDataRxIndicationCallback | cb | ) |

Register a callback function for the RX U-Data Indication - optional -.

See also
  TWiMDLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkUDataRxIndicationCallback for details

Note
  : the callback function should call the corresponding convert in order to decode the message properly

void WiMOD_SAP_RadioLink::RegisterUDataTxClient | ( | TRadioLinkUDataTxIndicationCallback | cb | ) |

Register a callback function for the TX U-Data Indication - optional -.

See also
  TWiMDLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkUDataTxIndicationCallback for details

TWiMDLRResultCodes WiMOD_SAP_RadioLink::SendCData | ( | const TWiMODLR_RadioLink_Msg * | txMsg,
|  | UINT8 * | statusRsp
| ) |  |

Tries to send transmit C-Data to peer module via RF link.

See also
  TWiMDLRResultCodes for interpretation of the values

Parameters

  txMsg | Data structure containing the TX-data and options.

See also
  TWiMODLR_RadioLink_Msg for details

Parameters

  statusRsp | Status byte contained in the local response of the module

Return values

  WiMODLR_RESULT_OK | if command transmit to WiMOD was ok

TWiMDLRResultCodes WiMOD_SAP_RadioLink::SendUData | ( | const TWiMODLR_RadioLink_Msg * | txMsg,
|  | UINT8 * | statusRsp
| ) |  |

Tries to send transmit U-Data to peer module via RF link.

See also
  TWiMDLRResultCodes for interpretation of the values

Parameters

  txMsg | Data structure containing the TX-data and options.

See also
  TWiMODLR_RadioLink_Msg for details

Parameters

  statusRsp | Status byte contained in the local response of the module

Return values

  WiMODLR_RESULT_OK | if command transmit to WiMOD was ok

TWiMDLRResultCodes WiMOD_SAP_RadioLink::SetAckData | ( | const TWiMODLR_RadioLink_Msg * | txMsg,
|  | UINT8 * | statusRsp
| ) |  |

Sets additional user payload for the next ack frame to send.

See also
  TWiMDLRResultCodes for interpretation of the values

Parameters

  txMsg | Pointer to data structure containing the payload data. note: Max ack payload size is 8 byte!

See also
  TWiMODLR_RadioLink_Msg for details

Parameters

  statusRsp | Status byte contained in the local response of the module

Return values

  WiMODLR_RESULT_OK | if command transmit to WiMOD was ok

The documentation for this class was generated from the following files:

- SAP/WiMOD_SAP_RadioLink.h
- SAP/WiMOD_SAP_RadioLink.cpp